#include <stdio.h>
#include <ode/ode.h>
#include "main.h"
#include "EpuckModel.h"
#include "MathFunction.h"

#include "Parameter.h"

struct Epuck EPUCK;

void MakeRobot() 
{
	dReal w1x = (dReal)BASE_r-0.095f;
	dReal w1z = - 0.005f;

	dMatrix3 R;
	dMass mass,mass1,mass2,mass3,mass4;
	int i;

  // 
    EPUCK.base2.body  = dBodyCreate(world);
	dMassSetZero(&mass4);
	dMassSetCylinderTotal(&mass4,(dReal)BASE_M1, 3,(dReal)BASE_r2,(dReal)BASE_l2);
	dBodySetMass(EPUCK.base2.body,&mass4);

    EPUCK.base1.body  = dBodyCreate(world);
	dMassSetZero(&mass1);
	dMassSetCylinderTotal(&mass1,(dReal)BASE_M2, 3,(dReal)BASE_r1,(dReal)BASE_l1);
	dBodySetMass(EPUCK.base1.body,&mass1);

	EPUCK.base.body  = dBodyCreate(world);
	dMassSetZero(&mass);
	dMassSetCylinderTotal(&mass,(dReal)BASE_M3, 3,(dReal)BASE_r,(dReal)BASE_l);
	dBodySetMass(EPUCK.base.body,&mass);

	EPUCK.base2.geom = dCreateCylinder(space,(dReal)BASE_r1,(dReal)BASE_l2);
	dGeomSetBody(EPUCK.base2.geom,EPUCK.base2.body);
	dBodySetPosition(EPUCK.base2.body,(dReal)START_X2,(dReal)START_Y2,(dReal)(dReal)START_Z2+BASE_l/2+BASE_l1+BASE_l2/2);

	EPUCK.base1.geom = dCreateCylinder(space,(dReal)BASE_r,(dReal)BASE_l1);
	dGeomSetBody(EPUCK.base1.geom,EPUCK.base1.body);
	dBodySetPosition(EPUCK.base1.body,(dReal)START_X1,(dReal)START_Y1,(dReal)START_Z1+BASE_l/2+BASE_l1/2/*+BASE_l2*/);

	EPUCK.base.geom = dCreateCylinder(space,(dReal)BASE_r,(dReal)BASE_l);
	dGeomSetBody(EPUCK.base.geom,EPUCK.base.body);
	dBodySetPosition(EPUCK.base.body,(dReal)START_X,(dReal)START_Y,(dReal)START_Z);

	EPUCK.Base_joint = dJointCreateFixed(world, 0); // Œ֐߁iyƒnʂ̌Œj
    dJointAttach(EPUCK.Base_joint, EPUCK.base1.body, EPUCK.base.body);          // Œ֐߂̎t
    dJointSetFixed(EPUCK.Base_joint); 

	EPUCK.Base2_joint = dJointCreateFixed(world, 0); // Œ֐߁iyƒnʂ̌Œj
    dJointAttach(EPUCK.Base2_joint, EPUCK.base2.body, EPUCK.base1.body);          // Œ֐߂̎t
    dJointSetFixed(EPUCK.Base2_joint); 


  // ԗ
	dRFromAxisAndAngle(R,0,1,0,M_PI/2.0);
	for (i = 0; i < WHEEL_MAX; i++) {
		EPUCK.wheel[i].body = dBodyCreate(world);   
		dMassSetZero(&mass);
		dMassSetCylinderTotal(&mass,(dReal)WH_M, 2, (dReal)WH_R, (dReal)WH_W);
		dBodySetMass(EPUCK.wheel[i].body,&mass);
		EPUCK.wheel[i].geom = dCreateCylinder(space, (dReal)WH_R, (dReal)WH_W);
		dGeomSetBody(EPUCK.wheel[i].geom, EPUCK.wheel[i].body);
		dBodySetRotation(EPUCK.wheel[i].body,R);
	}
	
	dBodySetPosition(EPUCK.wheel[0].body, -w1x+(dReal)START_X, (dReal)START_Y, w1z+(dReal)START_Z);  
	dBodySetPosition(EPUCK.wheel[1].body,  w1x+(dReal)START_X, (dReal)START_Y, w1z+(dReal)START_Z);
	
  // qWWCg
	for (i = 0; i < WHEEL_MAX; i++) {
		EPUCK.joint[i] = dJointCreateHinge(world,0);
		dJointAttach(EPUCK.joint[i], EPUCK.base.body, EPUCK.wheel[i].body);
	}
	dJointSetHingeAxis(EPUCK.joint[0],1, 0, 0);
	dJointSetHingeAxis(EPUCK.joint[1],1, 0, 0);
	dJointSetHingeAnchor(EPUCK.joint[0], -w1x+(dReal)START_X, (dReal)START_Y, w1z+(dReal)START_Z);
	dJointSetHingeAnchor(EPUCK.joint[1],  w1x+(dReal)START_X, (dReal)START_Y, w1z+(dReal)START_Z);  

	for (i = 0; i < SUB_SENSOR_MAX; i++) {
		EPUCK.ir_sensor[i].ray=dCreateRay (space,(dReal)SEN_R);
		EPUCK.ir_sensor[i].collide_flag=false;
	}
	//ZTpx0
	EPUCK.ir_sensor[0].ray_ang=Ray1_Ang;
	EPUCK.ir_sensor[1].ray_ang=Ray2_Ang;
	EPUCK.ir_sensor[2].ray_ang=Ray3_Ang;
	EPUCK.ir_sensor[3].ray_ang=Ray4_Ang;
	EPUCK.ir_sensor[4].ray_ang=Ray5_Ang;
	EPUCK.ir_sensor[5].ray_ang=Ray6_Ang;
	EPUCK.ir_sensor[6].ray_ang=Ray7_Ang;
	EPUCK.ir_sensor[7].ray_ang=Ray8_Ang;

	//TuZTpx
    EPUCK.ir_sensor[8].ray_ang=Ray9_Ang;
	EPUCK.ir_sensor[9].ray_ang=Ray10_Ang;
	EPUCK.ir_sensor[10].ray_ang=Ray11_Ang;
	EPUCK.ir_sensor[11].ray_ang=Ray12_Ang;
	EPUCK.ir_sensor[12].ray_ang=Ray13_Ang;
	EPUCK.ir_sensor[13].ray_ang=Ray14_Ang;
	EPUCK.ir_sensor[14].ray_ang=Ray15_Ang;
	EPUCK.ir_sensor[15].ray_ang=Ray16_Ang;
    EPUCK.ir_sensor[16].ray_ang=Ray17_Ang;
	EPUCK.ir_sensor[17].ray_ang=Ray18_Ang;
	EPUCK.ir_sensor[18].ray_ang=Ray19_Ang;
	EPUCK.ir_sensor[19].ray_ang=Ray20_Ang;
	EPUCK.ir_sensor[20].ray_ang=Ray21_Ang;
	EPUCK.ir_sensor[21].ray_ang=Ray22_Ang;
	EPUCK.ir_sensor[22].ray_ang=Ray23_Ang;
	EPUCK.ir_sensor[23].ray_ang=Ray24_Ang;

	EPUCK.pos =new dReal[3];


}

void DrawRobot()
{
	int i;

	// ԗ
	dsSetColor(1.0f,0.0f,0.5f);
	for (i=0; i< WHEEL_MAX; i++) {
		dsDrawCylinder(	dBodyGetPosition(EPUCK.wheel[i].body),
						dBodyGetRotation(EPUCK.wheel[i].body),(float)WH_W,(float)WH_R);
	}

	// 
    dsSetColorAlpha(0.0f,0.0f,0.0f,0.7f);
	dsDrawCylinder(dGeomGetPosition(EPUCK.base2.geom),
			     dGeomGetRotation(EPUCK.base2.geom),(float)BASE_l2,(float)BASE_r2);//ǉ掞t

    dsSetColorAlpha(0.0f,8.0f,0.5f,0.7f);
	dsDrawCylinder(dGeomGetPosition(EPUCK.base1.geom),
			     dGeomGetRotation(EPUCK.base1.geom),(float)BASE_l1,(float)BASE_r1);//ǉ掞t

	dsSetColorAlpha(0.5f,2.0f,2.1f,5.7f);
	dsDrawCylinder(dGeomGetPosition(EPUCK.base.geom),
			     dGeomGetRotation(EPUCK.base.geom),(float)BASE_l,(float)BASE_r);//ǉ掞t
	
	for (i=0; i< SENSOR_MAX; i++){
		if (EPUCK.ir_sensor[i].collide_flag==false){
			dsSetColor (1,1,1);
			dsDrawLine (EPUCK.ir_sensor[i].start_pos,EPUCK.ir_sensor[i].end_pos);
		}
		else {
			dsSetColor (1,0,0);
			dsDrawLine (EPUCK.ir_sensor[i].start_pos,EPUCK.ir_sensor[i].collide_pos[EPUCK.ir_sensor[i].collide_num]);
		}
	}

	for (i=SENSOR_MAX; i< SUB_SENSOR_MAX; i++){
		if (EPUCK.ir_sensor[i].collide_flag==false){
			dsSetColor (1,1,1);
			dsDrawLine (EPUCK.ir_sensor[i].start_pos,EPUCK.ir_sensor[i].end_pos);
		}
		else {
			dsSetColor (0,1,0);
			dsDrawLine (EPUCK.ir_sensor[i].start_pos,EPUCK.ir_sensor[i].collide_pos[EPUCK.ir_sensor[i].collide_num]);
		}
	}
}

/*** ԗւ̐ ***/
void ControlWheel(dReal right, dReal left)
{
	dReal fMax = 100.0;  // őgN
	dReal kl=1.08;//055;
	dReal kr=1.08;//055;

	dJointSetHingeParam(EPUCK.joint[1], dParamVel, kl*left);	//px[rad/s]̐ݒ
	dJointSetHingeParam(EPUCK.joint[1], dParamFMax, fMax);	//őgN[Nm]̐ݒ
	dJointSetHingeParam(EPUCK.joint[0], dParamVel, kr*right);
	dJointSetHingeParam(EPUCK.joint[0], dParamFMax, fMax);
}

void SensorSet(void){

	int i;
	
	for (i=0; i< SUB_SENSOR_MAX; i++){
		EPUCK.ir_sensor[i].collide_flag=false;
		EPUCK.ir_sensor[i].collide_cnt=0;
		EPUCK.ir_sensor[i].collide_num=0;

		dBodyGetRelPointPos(EPUCK.base.body,
							(dReal)(RAY_START_R*cos(-EPUCK.ir_sensor[i].ray_ang*PI/180+PI/2)),
							(dReal)(RAY_START_R*sin(-EPUCK.ir_sensor[i].ray_ang*PI/180+PI/2)),
							SENSOR_Z,
							EPUCK.ir_sensor[i].start_pos);
		dBodyGetRelPointPos(EPUCK.base.body,
							(dReal)(RAY_END_R*cos(-EPUCK.ir_sensor[i].ray_ang*PI/180+PI/2)),
							(dReal)(RAY_END_R*sin(-EPUCK.ir_sensor[i].ray_ang*PI/180+PI/2)),
							SENSOR_Z,
							EPUCK.ir_sensor[i].end_pos);
		dGeomRaySet (EPUCK.ir_sensor[i].ray, 
							EPUCK.ir_sensor[i].start_pos[0],
							EPUCK.ir_sensor[i].start_pos[1],
							EPUCK.ir_sensor[i].start_pos[2],
							EPUCK.ir_sensor[i].end_pos[0]-EPUCK.ir_sensor[i].start_pos[0], 
							EPUCK.ir_sensor[i].end_pos[1]-EPUCK.ir_sensor[i].start_pos[1],
							EPUCK.ir_sensor[i].end_pos[2]-EPUCK.ir_sensor[i].start_pos[2]);
	}

}


void GetIrSensorValue(int *sensor_value){
	
	int i,j;
	double ir_length[SUB_SENSOR_MAX];
	double ir_length_min[SUB_SENSOR_MAX];
	double value=0;
	double noise_value[SUB_SENSOR_MAX];

	for (i=0; i< SUB_SENSOR_MAX; i++){
		ir_length[i]=SEN_R;
	}

	for (i=0; i< SUB_SENSOR_MAX; i++){
		if(i<8){
			if(EPUCK.ir_sensor[i].collide_flag==true){
				if (EPUCK.ir_sensor[i].collide_cnt>1){
					ir_length_min[i]=sqrt(pow((EPUCK.ir_sensor[i].collide_pos[0][0]-EPUCK.ir_sensor[i].start_pos[0]),2)
								+pow((EPUCK.ir_sensor[i].collide_pos[0][1]-EPUCK.ir_sensor[i].start_pos[1]),2)
								+pow((EPUCK.ir_sensor[i].collide_pos[0][2]-EPUCK.ir_sensor[i].start_pos[2]),2));
					EPUCK.ir_sensor[i].collide_num=0;
					for(j=1;j<EPUCK.ir_sensor[i].collide_cnt;j++){
						ir_length[i]=sqrt(pow((EPUCK.ir_sensor[i].collide_pos[j][0]-EPUCK.ir_sensor[i].start_pos[0]),2)
								+pow((EPUCK.ir_sensor[i].collide_pos[j][1]-EPUCK.ir_sensor[i].start_pos[1]),2)
								+pow((EPUCK.ir_sensor[i].collide_pos[j][2]-EPUCK.ir_sensor[i].start_pos[2]),2));
						if(ir_length_min[i]>ir_length[i]){
							ir_length_min[i]=ir_length[i];
							EPUCK.ir_sensor[i].collide_num=j;
						}
					}
					ir_length[i]=ir_length_min[i];
				}
				else {
					EPUCK.ir_sensor[i].collide_num=0;
					ir_length[i]=sqrt(pow((EPUCK.ir_sensor[i].collide_pos[0][0]-EPUCK.ir_sensor[i].start_pos[0]),2)
							+pow((EPUCK.ir_sensor[i].collide_pos[0][1]-EPUCK.ir_sensor[i].start_pos[1]),2)
							+pow((EPUCK.ir_sensor[i].collide_pos[0][2]-EPUCK.ir_sensor[i].start_pos[2]),2));
				}
			}
			else {
				ir_length[i]=SEN_R;
			}
		}
		if(i>7 && i%2==0){
					if(EPUCK.ir_sensor[i].collide_flag==true){
				if (EPUCK.ir_sensor[i].collide_cnt>1){
					ir_length_min[i]=sqrt(pow((EPUCK.ir_sensor[i].collide_pos[0][0]-EPUCK.ir_sensor[i].start_pos[0]),2)
								+pow((EPUCK.ir_sensor[i].collide_pos[0][1]-EPUCK.ir_sensor[i].start_pos[1]),2)
								+pow((EPUCK.ir_sensor[i].collide_pos[0][2]-EPUCK.ir_sensor[i].start_pos[2]),2));
					EPUCK.ir_sensor[i].collide_num=0;
					for(j=1;j<EPUCK.ir_sensor[i].collide_cnt;j++){
						ir_length[i]=sqrt(pow((EPUCK.ir_sensor[i].collide_pos[j][0]-EPUCK.ir_sensor[i].start_pos[0]),2)
								+pow((EPUCK.ir_sensor[i].collide_pos[j][1]-EPUCK.ir_sensor[i].start_pos[1]),2)
								+pow((EPUCK.ir_sensor[i].collide_pos[j][2]-EPUCK.ir_sensor[i].start_pos[2]),2));
						if(ir_length_min[i]>ir_length[i]){
							ir_length_min[i]=ir_length[i];
							EPUCK.ir_sensor[i].collide_num=j;
						}
					}
					ir_length[i]=ir_length_min[i];
				}
				else {
					EPUCK.ir_sensor[i].collide_num=0;
					ir_length[i]=sqrt(pow((EPUCK.ir_sensor[i].collide_pos[0][0]-EPUCK.ir_sensor[i].start_pos[0]),2)
							+pow((EPUCK.ir_sensor[i].collide_pos[0][1]-EPUCK.ir_sensor[i].start_pos[1]),2)
							+pow((EPUCK.ir_sensor[i].collide_pos[0][2]-EPUCK.ir_sensor[i].start_pos[2]),2));
				}
			}
			else {
				ir_length[i]=SEN_R;
			}
		}
		if(i>7 && i%2==1){		
			if(EPUCK.ir_sensor[i].collide_flag==true){
				if (EPUCK.ir_sensor[i].collide_cnt>1){
					ir_length_min[i]=sqrt(pow((EPUCK.ir_sensor[i].collide_pos[0][0]-EPUCK.ir_sensor[i].start_pos[0]),2)
								+pow((EPUCK.ir_sensor[i].collide_pos[0][1]-EPUCK.ir_sensor[i].start_pos[1]),2)
								+pow((EPUCK.ir_sensor[i].collide_pos[0][2]-EPUCK.ir_sensor[i].start_pos[2]),2));
					EPUCK.ir_sensor[i].collide_num=0;
					for(j=1;j<EPUCK.ir_sensor[i].collide_cnt;j++){
						ir_length[i]=sqrt(pow((EPUCK.ir_sensor[i].collide_pos[j][0]-EPUCK.ir_sensor[i].start_pos[0]),2)
								+pow((EPUCK.ir_sensor[i].collide_pos[j][1]-EPUCK.ir_sensor[i].start_pos[1]),2)
								+pow((EPUCK.ir_sensor[i].collide_pos[j][2]-EPUCK.ir_sensor[i].start_pos[2]),2));
						if(ir_length_min[i]>ir_length[i]){
							ir_length_min[i]=ir_length[i];
							EPUCK.ir_sensor[i].collide_num=j;
						}
					}
					ir_length[i]=ir_length_min[i];
				}
				else {
					EPUCK.ir_sensor[i].collide_num=0;
					ir_length[i]=sqrt(pow((EPUCK.ir_sensor[i].collide_pos[0][0]-EPUCK.ir_sensor[i].start_pos[0]),2)
							+pow((EPUCK.ir_sensor[i].collide_pos[0][1]-EPUCK.ir_sensor[i].start_pos[1]),2)
							+pow((EPUCK.ir_sensor[i].collide_pos[0][2]-EPUCK.ir_sensor[i].start_pos[2]),2));
				}
			}
			else {
				ir_length[i]=SEN_R;
			}
		}
	}

	for(i=0;i<SENSOR_MAX;i++){
		value=(double)GaussApp(ir_length[i]*10,ir_length[i*2+8]*10,ir_length[i*2+9]*10);
		if(value<0){
			value=0;
		}
		noise_value[i]=NormalRandom(value, SENSOR_NOISE_RANGE*value);
		if(noise_value[i]<0){
			noise_value[i]=0;
		}
		sensor_value[i]=(int)noise_value[i];
	}

	for(i=0; i<SENSOR_MAX;i++){
		sensor_value[i]=(int)(0.4*sensor_value[i]);
		if (sensor_value[i]<0) 
			sensor_value[i]=0;
	}

}

/* ========== KEXW_@̊֐ =================*/
int GaussApp(double x1,double x2,double x3){
	double f;

//(f:ZTpx0j
f=
(474.896485)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(510.985436)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(397.688033)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(227.897532)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(92.666568)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(23.659588)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(2.625700)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-0.280501)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.124471)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.014904)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-16.035182)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-75.614200)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-42.531916)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(25.324040)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(35.708860)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(12.214299)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(0.054906)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-0.856705)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.194740)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.016701)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-517.568344)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-569.675957)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-320.812334)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-42.977739)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(43.396942)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(20.349946)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(1.603260)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-0.755835)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.182285)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.013747)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-516.014339)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-443.882199)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-120.293634)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(109.807712)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(104.640940)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(31.128772)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(1.066249)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-1.292440)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.248339)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.007500)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-205.971427)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-68.264181)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(137.703861)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(183.248231)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(83.169816)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(5.458070)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-8.009382)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-2.604414)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.149196)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.069232)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-11.239178)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(74.050266)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(125.775279)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(71.085539)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-10.315031)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-31.024502)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-13.856236)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-1.774002)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.456524)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.191544)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(16.390460)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(33.376741)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(14.375165)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-34.694957)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-56.117235)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-34.440774)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-8.554953)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(0.535233)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.753696)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.133434)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(2.721901)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-4.304693)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-25.736224)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-44.767225)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-38.727625)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-16.451678)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-1.788409)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(1.019011)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.244478)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.081298)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-1.635943)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-7.158092)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-15.738404)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-19.212235)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-12.260118)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-2.263974)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(1.990919)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(1.413233)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.310595)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.023282)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.828466)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-2.402560)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-3.888785)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-2.569973)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(2.314095)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(6.970008)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(7.567609)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(4.885683)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(2.056021)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.595451)*exp(-(x1-0.000000)*(x1-0.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(597.349254)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(685.992089)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(566.767919)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(324.210673)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(114.189829)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(16.547794)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-3.286591)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-1.800650)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.288061)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.016954)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(31.023319)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(49.508680)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(111.488626)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(107.803888)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(33.734060)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-11.380665)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-10.848988)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-2.820010)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.271169)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.000082)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-509.225034)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-447.856732)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-151.068037)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(37.466833)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(25.974167)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-11.407984)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-9.724799)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-2.019966)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.100745)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.002077)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-461.873185)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-268.970881)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(71.898747)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(180.244347)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(75.149156)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-2.293376)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-8.588360)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-1.877745)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.097760)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.003584)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-120.297272)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(90.237121)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(261.317594)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(187.296632)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(25.620493)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-30.399589)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-14.543460)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-1.197330)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.714388)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.244422)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(42.476722)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(139.051474)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(134.062120)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(6.922906)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-77.388158)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-53.012648)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-8.594473)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(4.648188)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(2.550608)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.506237)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(29.068166)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(30.536955)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-28.411602)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-98.156187)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-90.383810)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-28.646178)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(7.825790)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(8.547152)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(2.259772)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.101502)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.345904)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-19.019379)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-55.471426)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-70.666385)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-39.871683)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-0.507569)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(10.150285)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(3.529117)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.642369)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.691732)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-4.037090)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-13.840288)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-24.839218)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-22.402758)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-5.284329)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(7.019342)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(5.290630)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-0.001935)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-1.422138)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.719640)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-1.518678)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-3.750724)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-4.417963)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(0.845449)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(10.628892)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(16.524425)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(14.087983)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(7.657428)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(2.849273)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.915609)*exp(-(x1-0.777778)*(x1-0.777778)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(549.774265)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(660.530637)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(541.627491)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(271.777333)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(57.154013)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-14.305320)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-11.431624)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-2.481676)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.156038)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.015754)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(122.508479)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(194.910418)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(189.288665)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(59.194253)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-52.362939)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-53.776998)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-17.574269)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-1.690583)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.227503)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.035701)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-271.849887)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-164.970606)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-25.787391)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-34.121040)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-77.589436)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-47.484803)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-8.506064)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(1.038056)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.246274)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.100384)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-221.957531)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-39.200270)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(110.126030)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(56.761733)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-26.896051)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-23.375422)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-2.741993)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(0.216225)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.498694)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.211467)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(3.972187)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(158.064323)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(182.122804)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(40.928765)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-52.239136)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-34.220087)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-4.118348)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(2.063070)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.922904)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.244591)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(67.291741)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(107.837996)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(29.991887)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-90.426942)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-96.032605)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-21.433155)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(17.907501)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(13.582710)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(3.901724)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.555047)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(21.321108)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-5.995677)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-80.915268)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-113.956937)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-47.046599)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(30.255554)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(39.439258)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(15.084307)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(1.548203)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.399781)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-6.020624)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-32.372109)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-61.469994)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-45.632082)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(11.123970)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(39.322389)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(19.955931)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-1.578580)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-4.695609)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-1.591794)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-5.712691)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-15.094989)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-18.679861)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-3.247538)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(16.555688)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(13.500691)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-3.873408)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-10.495590)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-6.057716)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-1.636496)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-1.643364)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-2.969266)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-0.499435)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(8.572322)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(17.527548)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(17.047265)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(9.499088)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(3.395898)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(1.573326)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(1.785488)*exp(-(x1-1.555556)*(x1-1.555556)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(360.201618)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(428.084130)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(312.309040)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(101.533986)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-23.889715)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-32.161423)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-9.475455)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-0.420501)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.279852)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.043263)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(141.480112)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(172.522824)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(73.465980)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-78.718824)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-112.265444)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-47.170089)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-2.527464)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(3.215734)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.658190)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.043793)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-66.385768)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-38.503434)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-81.233589)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-142.187893)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-93.035362)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-6.657736)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(15.318376)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(4.181125)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.755410)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.447137)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-50.702468)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(5.449258)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-10.483806)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-47.940528)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-11.432908)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(23.782598)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(9.796723)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-4.246863)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-3.151064)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.539151)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(37.586814)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(76.250010)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(29.466665)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-27.776475)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-16.683091)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(1.916972)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-3.056658)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-4.490252)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.862591)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.354544)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(38.311340)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(23.768782)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-45.088197)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-75.255178)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-23.839029)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(24.316309)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(24.773771)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(10.193793)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(2.693593)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.644199)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(2.065510)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-30.909629)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-68.133576)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-38.557745)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(42.773372)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(74.226854)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(39.935126)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(6.414497)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-1.305710)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.038478)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-8.897838)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-25.626604)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-25.313353)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(18.422863)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(62.181677)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(44.870444)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-0.992542)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-15.560864)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-6.086397)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.262046)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-4.356620)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-7.289890)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.761648)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(19.564489)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(19.942916)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-9.393232)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-29.990262)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-20.820678)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-5.371623)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.359458)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.871157)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.271726)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(4.150521)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(9.735865)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(7.077009)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-3.044718)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-7.355003)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-2.651686)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(3.531613)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(6.614660)*exp(-(x1-2.333333)*(x1-2.333333)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(159.291293)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(170.817463)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(87.684475)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-13.068819)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-39.926868)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-15.702797)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(0.755893)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(1.880318)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.402845)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.007276)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(75.218222)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(51.751412)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-43.053924)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-100.374329)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-53.082516)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(7.304009)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(15.850019)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(4.587124)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.021572)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.207124)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-9.915190)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-43.874552)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-98.540010)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-71.222040)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(26.090466)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(58.507535)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(22.793591)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-1.526783)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-2.811584)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.540527)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-11.200991)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-21.095334)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-23.797479)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(36.376412)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(88.532953)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(47.079511)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-9.743617)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-16.065639)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-4.294262)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.092096)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(13.918385)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(13.461139)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(14.999601)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(39.959931)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(34.015103)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-15.122453)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-32.319136)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-12.185285)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.976002)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(1.491269)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(7.946072)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-5.342006)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-16.635771)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-3.288462)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(7.484562)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(0.479697)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-0.337477)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(4.720811)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(4.127998)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(1.333511)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-5.046457)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-18.163104)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-14.584834)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(22.826041)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(53.128482)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(37.805349)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(7.545226)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-1.914965)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(1.259603)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(2.231962)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-5.081774)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-6.904997)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(9.711216)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(40.561152)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(39.892619)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-2.689706)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-27.308087)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-11.308777)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(5.563165)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(5.580182)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-1.364219)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.960505)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(10.174982)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(13.678382)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-9.861416)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-39.650320)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-32.531680)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-3.366429)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(8.253688)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(4.268742)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.017601)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(1.207871)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(3.023526)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-0.689482)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-12.679600)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-18.261271)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-7.090964)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(6.760586)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(13.184844)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(15.336464)*exp(-(x1-3.111111)*(x1-3.111111)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(44.106189)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(35.700481)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.633481)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-21.391569)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-10.662306)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(4.322133)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(5.370717)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(1.630349)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.103445)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.035853)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(17.261951)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-6.977218)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-37.806361)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-22.734991)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(21.575991)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(32.414369)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(13.493662)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(0.879350)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.777638)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.171162)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-7.882696)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-26.931242)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-17.441559)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(47.063568)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(87.649671)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(49.857184)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(2.197579)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-7.668959)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-2.282584)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.065157)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-5.178146)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.034901)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(44.828845)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(103.134048)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(80.102267)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-2.143847)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-33.215499)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-13.619887)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.581571)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(1.390304)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(4.384818)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(17.674769)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(48.348171)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(52.517420)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-9.099934)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-58.246539)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-33.908710)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(2.192260)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(7.380039)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(1.773823)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(2.105303)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(5.364097)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(10.595718)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-1.953422)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-30.236295)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-27.714438)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(3.172855)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(14.523662)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(5.677727)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.305567)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-1.699817)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-1.616017)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(4.467435)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(9.953568)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(5.370057)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-0.565669)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(1.162957)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(4.374320)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(3.950522)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(1.736657)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.887621)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(1.931554)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(10.566404)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(12.801475)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-6.647897)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-25.713978)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-12.329556)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(12.712505)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(15.942359)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(5.401170)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.201912)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(2.243787)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(3.845771)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-5.812270)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-26.335308)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-25.859486)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(5.919583)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(25.069831)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(12.898975)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-1.065049)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.183751)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.500595)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-1.150252)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-7.982679)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-13.281362)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-3.079782)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(13.233923)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(15.121352)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(12.504120)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(17.886450)*exp(-(x1-3.888889)*(x1-3.888889)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(6.769497)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(1.971300)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-4.634435)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-2.400968)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(5.311974)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(6.808509)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(2.955658)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(0.374748)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.082560)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.022992)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.437149)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-5.562109)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-2.105057)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(17.556369)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(29.086293)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(17.503963)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(2.783028)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-1.275020)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.459201)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.025144)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-2.666649)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.846325)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(26.015368)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(56.387354)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(46.933734)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(8.684455)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-9.060398)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-4.285413)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.367397)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.547322)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(1.866512)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(17.263070)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(48.811512)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(56.043142)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(10.483635)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-28.944525)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-18.405435)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(2.255382)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(4.808606)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(1.120342)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(5.029511)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(18.159098)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(28.853072)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(4.080402)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-39.702227)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-35.177527)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(5.395022)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(18.239258)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(6.105853)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-1.154049)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(2.559123)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(5.853255)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.566465)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-20.711767)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-27.554658)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(3.472628)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(26.858624)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(13.262813)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-3.627132)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-4.916052)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.270069)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.440292)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-2.016305)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-6.540343)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-2.910240)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(7.843690)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(7.474845)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-1.978942)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-4.646172)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-2.159382)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.157174)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.958554)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.784479)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-4.329104)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-11.573322)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-8.333119)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(5.983316)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(13.441552)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(6.947211)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-1.854790)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.203925)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.380067)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-1.821591)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-8.907354)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-11.576351)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(4.886828)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(24.085036)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(15.606631)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-7.220884)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-14.253670)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.037165)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.281736)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-2.070214)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-4.371515)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-0.032190)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(11.059218)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(9.289165)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-7.064721)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-6.758120)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(14.480042)*exp(-(x1-4.666667)*(x1-4.666667)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.428251)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.313047)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.097924)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(2.517557)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(3.912812)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(2.440298)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(0.533641)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-0.078566)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.041038)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.003340)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.219686)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.588889)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(5.675165)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(11.752300)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(10.240993)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(3.002875)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-0.872879)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-0.558587)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.079027)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.091537)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.689030)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(5.804031)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(16.152432)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(19.645967)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(7.514312)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-4.491506)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-3.585372)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(0.821831)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(1.262857)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.298847)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(2.690078)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(10.055602)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(17.035021)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(8.162820)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-10.520902)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-10.786736)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(3.683856)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(7.882794)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(2.661399)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.403821)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(2.777686)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(6.547805)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(3.733414)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-10.889016)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-14.973960)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(6.762066)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(21.578468)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(10.315881)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-2.471772)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-3.623856)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(1.069746)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.717947)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-4.671845)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-9.255320)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(4.247600)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(24.059186)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(16.154320)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-7.068637)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-12.560543)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-5.322426)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.074571)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.678688)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-2.341740)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-0.190154)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(8.085465)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(7.533798)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-8.587299)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-16.532595)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-7.552628)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.427075)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.009084)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.183893)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-0.904874)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-1.867041)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-2.603910)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-3.583996)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-3.009757)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(0.869585)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(2.078603)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-2.807204)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.004426)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.263589)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-1.456302)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-2.877330)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-0.333637)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(6.447168)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(6.169358)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-6.210050)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-17.190098)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-16.734111)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.028381)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.250081)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-0.736287)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-0.115028)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(3.066641)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(1.759968)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-13.429677)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-26.494599)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-11.882809)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(19.769666)*exp(-(x1-5.444444)*(x1-5.444444)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.008769)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.081098)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.511957)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(1.031890)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(0.926977)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(0.327909)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-0.025282)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-0.033414)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.006380)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.006717)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.114950)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.793690)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(2.169241)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(2.738694)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(1.340773)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-0.214393)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-0.305345)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(0.105372)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.140963)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.033847)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.562411)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(2.099186)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(3.724379)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(2.492026)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-0.834465)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-1.321624)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(0.776547)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(1.368664)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.471819)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.057837)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.928599)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(2.312535)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(2.079500)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-1.473313)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-2.714757)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(2.520555)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(6.062020)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(2.977629)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.500731)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.929436)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.647217)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.767173)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-1.157303)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-2.639719)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(3.494240)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(11.956859)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(8.278290)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-2.211383)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-5.229701)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-2.454876)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.123583)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.389281)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-1.200075)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(1.902138)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(9.985769)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(9.559927)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-4.990537)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-13.455781)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-7.194302)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.764624)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.050934)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.247736)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.272728)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(3.027002)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(3.780156)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-5.524138)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-15.237764)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-8.006892)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(4.725484)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(4.582219)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.022019)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.053623)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.045562)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-0.157087)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-2.830917)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-6.779955)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-2.347101)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(10.585206)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(12.990708)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.084810)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.015948)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.104267)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-0.350761)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-0.666725)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-0.695033)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(0.083794)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(2.028658)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(2.398469)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-3.978548)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-12.969153)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.014177)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.063717)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-0.083523)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(0.136297)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-0.403648)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-5.022010)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-12.551696)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-12.094405)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(2.689522)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(24.963729)*exp(-(x1-6.222222)*(x1-6.222222)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.007735)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.046488)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.125848)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(0.163106)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(0.090195)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(0.001072)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-0.012247)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(0.005399)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.006960)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(0.001685)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.000000)*(x2-0.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.049707)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.184568)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.337673)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(0.262987)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-0.002807)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-0.073355)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(0.062105)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(0.102058)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.035675)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.004158)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-0.777778)*(x2-0.777778)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.125166)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.323450)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.352657)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-0.026657)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-0.207187)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(0.322202)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(0.695652)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(0.349211)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.047816)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.106047)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-1.555556)*(x2-1.555556)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.142494)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.215790)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-0.051173)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-0.278917)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(0.747668)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(2.178848)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(1.559171)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-0.273966)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-0.885922)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.468864)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-2.333333)*(x2-2.333333)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.059658)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.036311)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-0.181520)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(0.761498)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(3.078719)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(3.106008)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-0.837555)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-3.464611)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(-2.182945)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-0.531892)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.111111)*(x2-3.111111)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.010323)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.057830)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.325707)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(1.895392)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(2.642131)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-1.415813)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-6.361659)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(-4.226846)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.916281)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(1.368503)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-3.888889)*(x2-3.888889)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.009044)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.051064)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.466179)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(0.851200)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-1.267202)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-5.488814)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(-3.108445)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(7.366331)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(11.052355)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(3.001800)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-4.666667)*(x2-4.666667)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(0.000860)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(0.030925)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(0.047269)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-0.555276)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-2.207762)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-0.774769)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(9.844835)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(20.843039)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(14.183118)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-4.794591)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-5.444444)*(x2-5.444444)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.002645)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.018102)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-0.113679)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-0.407164)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-0.221851)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(3.377351)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(11.443901)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(13.962323)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(0.050207)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(-18.217586)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-6.222222)*(x2-6.222222)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)
+(-0.002668)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.000000)*(x3-0.000000)/3.240000)
+(-0.010988)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-0.777778)*(x3-0.777778)/3.240000)
+(-0.035275)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-1.555556)*(x3-1.555556)/3.240000)
+(-0.142950)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-2.333333)*(x3-2.333333)/3.240000)
+(-0.438079)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.111111)*(x3-3.111111)/3.240000)
+(-0.341495)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-3.888889)*(x3-3.888889)/3.240000)
+(1.341400)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-4.666667)*(x3-4.666667)/3.240000)
+(3.068168)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-5.444444)*(x3-5.444444)/3.240000)
+(3.930836)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-6.222222)*(x3-6.222222)/3.240000)
+(12.733388)*exp(-(x1-7.000000)*(x1-7.000000)/3.240000 - (x2-7.000000)*(x2-7.000000)/3.240000 - (x3-7.000000)*(x3-7.000000)/3.240000)  ;
	return (int)(f+0.5);
}
